#!/bin/bash

#	Задаем переменные
d=15;		#диаметр цилиндра
l=700;		#длина зоны
a=400;		#ширина зоны
x_cyl=270;	#расстояние от входа до оси цилиндра
z0=-1;		#координаты пластины
z1=1;

#	Вычисляем коэффициент дробления
c1=50;								#по ширине зоны
c2=`echo "scale=0; ($l-$x_cyl)*$c1/$a" | bc -lq`;		#по длине зоны следа
c3=100;								#область рядом с цилиндром
c4=`echo "scale=0; $x_cyl*$c1/$a" | bc -lq`;			#по длине зоны набегающего потока
m1=0.01;								#степень сжатия ячеек около цилиндра
#	Вычисляем координаты
x0=-$x_cyl;
y0=`echo "-$a/2" | bc -lq`;
x1=`echo "-$a/2" | bc -lq`;
y1=$y0;
x2=0;
y2=$y0;
x3=`echo "-($x1)" | bc -lq`;
y3=$y0;
x4=`echo "$l-$x_cyl" | bc -lq`;
y4=$y0;
x5=$x0;
y5=0;
x6=$x1;
y6=0;
x7=`echo "-$d/2" | bc -lq`;
y7=0;
x8=`echo "-$d/2*sqrt(2)/2" | bc -lq`;
y8=$x8;
x9=0;
y9=`echo "-$d/2" | bc -lq`;
x10=`echo "-($x8)" | bc -lq`;
y10=$y8;
x11=`echo "$d/2" | bc -lq `;
y11=0;
x12=$x3;
y12=0;
x13=$x4;
y13=0;
x14=$x8;
y14=`echo "$d/2*sqrt(2)/2" | bc -lq`;
x15=0;
y15=`echo "$d/2" | bc -lq`
x16=`echo "$d/2*sqrt(2)/2" | bc -lq`;
y16=$x16;
x17=$x0;
y17=`echo "$a/2" | bc -lq`
x18=$x1;
y18=$y17;
x19=$x2;
y19=$y17;
x20=$x3;
y20=$y17;
x21=$x4;
y21=$y17;



#	Генерируем blockMeshDict
#генерируем blockMeshDict
echo '/*--------------------------------*- C++ -*----------------------------------*\';
echo '| =========                 |                                                 |';
echo '| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |';
echo '|  \\    /   O peration     | Version:  2.1.1                                 |';
echo '|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |';
echo '|    \\/     M anipulation  | Source:   azagoskin.ru / Zagoskin Andrey        |';
echo '\*---------------------------------------------------------------------------*/';
echo 'FoamFile';
echo '{';
echo '    version     2.0;';
echo '    format      ascii;';
echo '    class       dictionary;';
echo '    object      blockMeshDict;';
echo '}';
echo '// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //';
echo '';
echo 'convertToMeters 0.001;';
echo '';
echo 'vertices';
echo '(';

for k in $z0 $z1
do
       i=0
        while [ $i -lt 22 ]
        do
                string1=$'x'$i;
                string2=$'y'$i;
                echo "(${!string1} ${!string2} $k)";
                i=$[$i+1];
        done;
done;
echo ');';
echo "blocks";
echo '(';
echo "hex (0 2 6 5 22 24 28 27) ($c4 $c1 1) simpleGrading (1 1 1)";
echo "hex (6 2 9 7 28 24 31 29) ($c1 $c3 1) simpleGrading (1 $m1 1)";
echo "hex (2 12 11 9 24 34 33 31) ($c1 $c3 1) simpleGrading (1 $m1 1)";
echo "hex (2 4 13 12 24 26 35 34) ($c2 $c1 1) simpleGrading (1 1 1)";
echo "hex (5 6 19 17 27 28 41 39) ($c4 $c1 1) simpleGrading (1 1 1)";
echo "hex (19 6 7 15 41 28 29 37) ($c1 $c3 1) simpleGrading (1 $m1 1)";
echo "hex (12 19 15 11 34 41 37 33) ($c1 $c3 1) simpleGrading (1 $m1 1)";
echo "hex (12 13 21 19 34 35 43 41) ($c2 $c1 1) simpleGrading (1 1 1)";
echo ');';
echo "edges"
echo '(';
echo "arc 7 9 ($x8 $y8 $z0)"
echo "arc 9 11 ($x10 $y10 $z0)"
echo "arc 7 15 ($x14 $y14 $z0)"
echo "arc 11 15 ($x16 $y16 $z0)"
echo "arc 29 31 ($x8 $y8 $z1)"
echo "arc 31 33 ($x10 $y10 $z1)"
echo "arc 29 37 ($x14 $y14 $z1)"
echo "arc 37 33 ($x16 $y16 $z1)"
echo ');';
echo "boundary";
        echo '(';
        echo "inlet"
                echo '{';
                echo "type patch;";
                echo "faces"
                        echo '(';
                        echo '(0 22 27 5)';
                        echo '(5 27 39 17)';
                        echo ');';
                echo '}'
        echo "outlet"
                echo '{';
                echo "type patch;";
                echo "faces"
                        echo '(';
                        echo '(35 13 21 43)';
                        echo '(26 4 13 35)';
                        echo ');';
                echo '}'
        echo "cylinder"
                echo '{';
                echo "type wall;";
                echo "faces"
                        echo '(';
                        echo '(9 7 29 31)';
                        echo '(11 9 31 33)';
                        echo '(15 11 33 37)';
                        echo '(7 15 37 29)';
                        echo ');';
                echo '}'
        echo "up"
                echo '{';
                echo "type patch;";
                echo "faces"
                        echo '(';
                        echo '(41 19 17 39)';
                        echo '(43 21 19 41)';
                        echo ');';
                echo '}'
        echo "bottom"
                echo '{';
                echo "type patch;";
                echo "faces"
                        echo '(';
                        echo '(0 2 24 22)';
                        echo '(2 4 26 24)';
                        echo ');';
                echo '}'
        echo ');';
echo "mergePatchPairs"
echo '(';
echo ');';

echo '// ************************************************************************* //';

